<template>
  <div id="CreateFault">
    <Navbar />
    <div class="mt-5">
      <div class="container">
        <div class="row">
          <div class="col-lg-6 col-md-6 col-sm-12">
            <div class="login-box shadow-sm mb-5 bg-white rounded">
              <div class="p-5">
                <h5>Crear una falta:</h5>
                <form @submit.prevent="addNewFault">
                 <div>
                   <select v-model="selected1" class="w-100">
                     <option v-for="item in this.family_users" v-bind:key="item">{{item}}</option>
                   </select>
                 </div>
                 <div>
                   <select v-model="selected2" class="w-100 mt-4">
                     <option  v-for="(rule1, key1) in rules[filterOptions(rules)]" :key="key1"   ><p v-if="rule1!=null && rule1!==undefined">{{rule1.name}}</p></option>
                   </select>
                 </div>
                 <div class="mt-4">
                  <button  type="submit" class="btn btn-primary w-100 btn-md">CREAR</button>
                </div>
                <div class="mt-3">
           <button type="button" class="btn btn-outline-warning btn-md w-100"  @click="returnFault" >ATRÁS</button>
         </div>
              </form>
            </div>
          </div>
        </div>
        <div class="col-lg-6 col-md-6 col-sm-12 text-right">
          <img src="@/assets/mirage-bad.png" width="340px;">
        </div>        
      </div>
    </div>
  </div>
</div>
</template>

<script>
  import Navbar from '@/components/Navbar.vue'
  import { mapState, mapGetters } from 'vuex'
  import { RTDB } from '../main.js';

  export default {
    computed:{
      ...mapGetters(['getCodeFamily']),
    },
    name: 'CreateFault',
    data () {
      return {
        family_users: [],
        rules: [],
        selected1: "",
        selected2: "",
      };
    },
    components: {
      Navbar
    },  methods: {
      addNewFault (submitEvent) {
      //TODO cambiar CODIGODEFAMILIA por el verdadero
      RTDB.ref('family/'+this.getCodeFamily+'/fault/'+this.getNextExpenseNumber()).set({
        user: this.selected1,
        rule: this.selected2,
      });
      this.selected1 = '';
      this.selected2 = '';
    },
    returnFault(){
      console.log("Aqui entro");
      this.$router.push({name:'fault'})
    },
    getNextExpenseNumber (){
      let number=0;
      RTDB.ref('family/'+this.getCodeFamily+'/fault/').on('value',function (snapshot){
        for (let expense in snapshot.val()){
          number = expense;
        }
        console.log(number);
      });
      number++;
      return number;
    },
    filterOptions(options){
      let lastIndex=0;
      lastIndex = options.length;
      lastIndex--;
      return lastIndex;
    }

  },
  mounted(){
    let all = this;
    const axios = require('axios').default;
    axios.get("http://localhost:55275/AppartamentoService.svc/GetUsersOfFamilyAsync/"+this.getCodeFamily).then(function (response){

     var result = response.data.split(",");
     result.forEach(element => {
      RTDB.ref('usuario/'+element+'/correo').on('value',snapshot=>{
        all.family_users.push(snapshot.val())});

    });

   });

    RTDB.ref('family/'+this.getCodeFamily+"/rule/").on('value',snapshot=>{
      all.rules.push(snapshot.val())});

  }
};
</script>
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.container{
  max-width: 960px;
}
.login-box{
  max-width: 480px;
}
select, .form-input, .form-input:focus{
  border-color: #3C394A;
  border-bottom-width: 2px;
  border-top: 0;
  border-right: 0;
  border-left: 0;
  border-radius: 0;
  box-shadow: none;
  max-width: 100%;
}
select, .form-input:focus{
  border-color: #009A9A;
}
.btn-primary {
  color: #fff;
  background-color: #009A9A;
  border-color: #009A9A;
}
.btn-primary:hover{
  background-color: #45b5b5 !important;
}

h5, h3 {
  color: #45b5b5;
  font-weight: bold;
}
.btn-outline-warning {
  color: #009A9A;
  border-color: #009A9A;
}
.btn-outline-warning:hover {
  background-color: #009A9A;
  color: #fafafa;
  border-color: #fafafa;
}
</style>
